#!/bin/sh
## File:     configurator-config for libconfigurator
## Author:   Georg Martius 
## Date:     Oct 2011

define(`COMMENT', )
COMMENT(`There are defines for platform dependend stuff.
         DEV only produces output in the development version
         DEVORUSER  choice between development (first argument) or user (second)
         LINUXORMAC outputs the first argument on linux and the second on mac.
         GSL outputs the first argument of GSL is used or second if not
         Call the m4 processor with -D PREFIX=... 
                                    -D MAC|LINUX -D VERSION=...
         The SRCPREFIX is only requried for DEVEL
         ')
COMMENT(`Comment for processed file:')
# Do not edit, this is file generated by m4 from selforg-config.m4

ifdef(`MAC', 
`define(`LINUXORMAC', $2)'
,
`define(`LINUXORMAC', $1)'
)

COMMENT(`change quote syntax to [[string]]')
changequote([[,]]) 

prefix="PREFIX"

LIBBASE=configurator

## use -pg for profiling
CBASEFLAGS="" 
CPPFLAGS="$CBASEFLAGS"
QPREFIX=`qmake -query QT_INSTALL_LIBS`
LIBS="-L$QPREFIX -lQtCore -lQtGui -lQtXml"
STATICSTART=
STATICEND=


usage="\
Usage: configurator-config [--prefix[=DIR]] [--version] [--static] [--cflags] [--libs]"

if test $# -eq 0; then
      echo "${usage}" 1>&2
      exit 1
fi

while test $# -gt 0; do
  case "$1" in
  -*=*) optarg=`echo "$1" | sed 's/[-_a-zA-Z0-9]*=//'` ;;
  *) optarg= ;;
  esac

  case $1 in
    --prefix=*)
      prefix=$optarg
      ;;
    --prefix)
      echo $prefix
      ;;
    --version)
      echo VERSION
      ;;
    --static)
      STATICSTART=-Wl,-Bstatic
      STATICEND=-Wl,-Bdynamic
      ;;
    --cflags)
      echo $CPPFLAGS -I"$prefix/include"
      ;;
    --libs)
      echo -L"$prefix/lib" $STATICSTART -l$LIBBASE $STATICEND $LIBS 
      ;;
    *)
      echo "Syntax Error: $0 $@" 1>&2
      echo "${usage}" 1>&2
      exit 1
      ;;
  esac
  shift
done
